﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Threading.Tasks;
using System.Drawing;

namespace solution1
{
	class ClassSearch
	{
		public ClassSearch(string[,] dt, int width, int height)
		{
			this.width = width;
			this.height = height;

			map = new dd[width, height];
			data = dt;
		}
		public struct dd
		{
			public int zn;
			public bool pos;
		}

		public struct state
		{
			int Hp;
			int[] keys;
			Point location;
		}

		internal int startPosX = 0, startPosY = 0, endPosX = 0, endPosY = 0, endPostX, endPostY;
		int width, height;

		static dd[,] map;
		static internal dd[,] Map { get => map; set => map = value; }

		string[,] data;

		internal static int count = 2;
		int vozvr;

		internal static Stack<Point> points = new Stack<Point>();

		internal static string output = "";
		public void FillMass()
		{
			for (int x = 0; x < width; x++)
			{
				for (int y = 0; y < height; y++)
				{
					string s = data[x, y];
					switch (s)
					{
						case "X":
							{
								map[x, y].zn = 0;
							}
							break;
						case "P":
							{
								map[x, y].zn = -1;
							}
							break;
						case "H":
							{
								map[x, y].zn = -2;
							}
							break;
						default:
							map[x, y].zn = 1; break;
					}
					if (data[x, y] == "S") { startPosX = x; startPosY = y; }
					if (data[x, y] == "E")
					{
						endPosX = x;
						endPosY = y;
						endPostX = x;
						endPostY = y;
					}
					map[x, y].pos = false;
				}
			}
		}

		public void DrawMap(int type)
		{
			switch (type)
			{
				case 1:
					{
						map[startPosX, startPosY].pos = true;
						map[startPosX, startPosY].zn = 2;
						while (map[endPosX, endPosY].zn == 1)
						{
							for (int x = 0; x < width; x++)
							{
								for (int y = 0; y < height; y++)
								{
									if (map[x, y].zn == count)
									{
										Step(x, y, count + 1, 1, width, height);
										Step(x, y, count + 1, -1, width, height);
										Step(x, y, count + 1, 2, width, height);
										Step(x, y, count + 1, -2, width, height);
									}
								}
							}
							count++;
						}
						vozvr = count;
					}
					break;
				case 2:
					{
						while (map[startPosX, startPosY].zn != vozvr)
						{
							for (int x = 0; x < width; x++)
							{
								for (int y = 0; y < height; y++)
								{
									if (map[x, y].zn == vozvr && endPostX == x && endPostY == y)
									{
										NextStep(x, y, vozvr, 1, width, height);
										NextStep(x, y, vozvr, -1, width, height);
										NextStep(x, y, vozvr, 2, width, height);
										NextStep(x, y, vozvr, -2, width, height);
										points.Push(new Point(x, y));
									}
								}
							}
							vozvr--;
						}
					}
					break;
			}
		}

		void Step(int x, int y, int count, int sm, int width, int height)
		{
			switch (sm)
			{
				case 2:
					{
						if (x + 1 >= height || map[x + 1, y].zn == 0 || map[x + 1, y].pos)
							return;
						else
						{
							map[x + 1, y].zn = count;
							map[x + 1, y].pos = true;
						}
					}
					break;
				case -2:
					{
						if (x - 1 < 0 || map[x - 1, y].zn == 0 || map[x - 1, y].pos)
							return;
						else
						{
							map[x - 1, y].pos = true;
							map[x - 1, y].zn = count;
						}
					}
					break;
				case 1:
					{
						if (y + 1 >= width || map[x, y + 1].zn == 0 || map[x, y + 1].pos)
							return;
						else
						{
							map[x, y + 1].zn = count;
							map[x, y + 1].pos = true;
						}
					}
					break;
				case -1:
					{
						if (y - 1 < 0 || map[x, y - 1].zn == 0 || map[x, y - 1].pos)
							return;
						else
						{
							map[x, y - 1].zn = count;
							map[x, y - 1].pos = true;
						}
					}
					break;
			}
		}

		void NextStep(int x, int y, int count, int sm, int width, int height)
		{
			switch (sm)
			{
				case 2:
					{
						if (x + 1 < height && map[x + 1, y].pos && map[x + 1, y].zn == count - 1)
						{
							output += "U";
							endPostX = x + 1;
						}
					}
					break;
				case -2:
					{
						if (x - 1 >= 0 && map[x - 1, y].pos && map[x - 1, y].zn == count - 1)
						{
							output += "D";
							endPostX = x - 1;
						}
					}
					break;
				case 1:
					{
						if (y + 1 < width && map[x, y + 1].pos && map[x, y + 1].zn == count - 1)
						{
							output += "L";
							endPostY = y + 1;
						}
					}
					break;
				case -1:
					{
						if (y - 1 >= 0 && map[x, y - 1].pos && map[x, y - 1].zn == count - 1)
						{
							output += "R";
							endPostY = y - 1;
						}
					}
					break;
			}
		}
	}
}
