﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace solution1
{
	public partial class Form1 : Form
	{
		int width, height;
		string[,] data;
		PictureBox[,] pictures;
		ClassSearch search;
		int startX, startY;
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			try
			{
				OpenFileDialog openFile = new OpenFileDialog();
				openFile.RestoreDirectory = true;
				openFile.Multiselect = false;
				openFile.ShowDialog();
				if (openFile.FileName == "")
				{
					FormMenu frm = new FormMenu();
					frm.Show();
					Close();
				}
				else
				{
					StreamReader rd = new StreamReader(openFile.FileName);

					string[] inp = rd.ReadLine().Split();
					int wdt = int.Parse(inp[0]);
					int hgh = int.Parse(inp[1]);
					width = wdt;
					height = hgh;
					data = new string[wdt, hgh];
					pictures = new PictureBox[width, height];
					for (int i = 0; i < wdt; i++)
					{
						string[] dt1 = rd.ReadLine().Split();
						for (int j = 0; j < hgh; j++)
						{
							data[i, j] = dt1[j];
						}
					}
					rd.Close();
					search = new ClassSearch(data, wdt, hgh);
					search.FillMass();
					search.DrawMap(1);
					search.DrawMap(2);
				}
			}
			catch { }

			startX = search.startPosX;
			startY = search.startPosY;

			DrawPlace();
			label2.Text = 0+ "";
			timer1.Start();
		}

		void DrawPlace()
		{
			for (int x = 0; x < width; x++)
			{
				for (int y = 0; y < height; y++)
				{
					PictureBox pic = new PictureBox
					{
						Location = new Point(y * 30, x * 30),
						Size = new Size(29, 29),
						BackColor = DrawColor(data[x, y]),
						BorderStyle = BorderStyle.FixedSingle,
					};
					pictures[x, y] = pic;
					panel1.Controls.Add(pic);
				}
			}
		}

		private void Timer1_Tick(object sender, EventArgs e)
		{
			if (ClassSearch.points.Count != 0)
			{
				label2.Text = (int.Parse(label2.Text) + 1).ToString();
				Point pt = ClassSearch.points.Pop();

				pictures[pt.X, pt.Y].BackColor = Color.Yellow;
				pictures[startX, startY].BackColor = Color.Gray;
				startX = pt.X;
				startY = pt.Y;
			}
			else
			{
				timer1.Stop();
				Form form = new Form
				{
					StartPosition = FormStartPosition.CenterScreen,
					Size = new Size(180, 200),
					FormBorderStyle = FormBorderStyle.FixedSingle,
				};
				Label lab1 = new Label
				{
					Location = new Point(40, 10),
					Text = "GAME ENDED"
				};
				Label lab2 = new Label
				{
					Location = new Point(50, 40),
					Text = "YOU WIN!"
				};
				Label lab3 = new Label
				{
					Location = new Point(45, 70),
					Text = "STEPS: " + (ClassSearch.count-2),
				};
				Button butt = new Button
				{
					Location = new Point(30, 100),
					DialogResult = DialogResult.Yes,
					Text = "Back to menu",
					Width = 100,
				};
				form.Controls.Add(lab1);
				form.Controls.Add(lab2);
				form.Controls.Add(lab3);
				form.Controls.Add(butt);
				if ((DialogResult)form.ShowDialog() == DialogResult.Yes)
				{
					FormMenu frm = new FormMenu();
					frm.Show();
					Close();
				}
			}
		}

		Color DrawColor(string inp)
		{
			switch (inp)
			{
				case "X": return Color.Black;
				case "S": return Color.Yellow;
				case ".": return Color.Gray;
				case "E": return Color.Green;
				default: return Color.Black;
			}
		}
	}
}
